# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1Customer(Model):
    """Describes a customer resource. The base customer profile for
    CustomerCompany and CustomerBilling profiles.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param id: Gets or sets the customer identifier.
    :type id: str
    :param commerce_id: Gets or sets the commerce identifier.
    :type commerce_id: str
    :param company_profile: Gets or sets the company profile. Additional
     information about the company or organization.
    :type company_profile:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CustomerCompanyProfile
    :param billing_profile: Gets or sets the billing profile. Additional
     information used for billing.
    :type billing_profile:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CustomerBillingProfile
    :param relationship_to_partner: Gets or sets the relationship to a
     partner, by defining the licensing program that the partner uses for this
     customer. Possible values include: 'unknown', 'reseller', 'advisor',
     'syndication', 'microsoft_support', 'none'
    :type relationship_to_partner: str or
     ~microsoft.store.partnercenterservices.models.enum
    :param allow_delegated_access: Gets or sets a value that indicates whether
     the partner has been granted delegated admin privileges by this customer.
    :type allow_delegated_access: bool
    :param user_credentials: Gets or sets the user credentials.
    :type user_credentials:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1UserCredentials
    :param associated_partner_id: Gets or sets the indirect reseller
     associated to this customer account.
     This value can be set only by indirect CSP partners.
    :type associated_partner_id: str
    :param custom_domains: Gets or sets a list of custom domains.
    :type custom_domains: list[str]
    :param links: Gets or sets the links.
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceLinks
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'commerce_id': {'key': 'commerceId', 'type': 'str'},
        'company_profile': {'key': 'companyProfile', 'type': 'MicrosoftPartnerSdkContractsV1CustomerCompanyProfile'},
        'billing_profile': {'key': 'billingProfile', 'type': 'MicrosoftPartnerSdkContractsV1CustomerBillingProfile'},
        'relationship_to_partner': {'key': 'relationshipToPartner', 'type': 'str'},
        'allow_delegated_access': {'key': 'allowDelegatedAccess', 'type': 'bool'},
        'user_credentials': {'key': 'userCredentials', 'type': 'MicrosoftPartnerSdkContractsV1UserCredentials'},
        'associated_partner_id': {'key': 'associatedPartnerId', 'type': 'str'},
        'custom_domains': {'key': 'customDomains', 'type': '[str]'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceLinks'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, id=None, commerce_id=None, company_profile=None, billing_profile=None, relationship_to_partner=None, allow_delegated_access=None, user_credentials=None, associated_partner_id=None, custom_domains=None, links=None):
        super(MicrosoftPartnerSdkContractsV1Customer, self).__init__()
        self.id = id
        self.commerce_id = commerce_id
        self.company_profile = company_profile
        self.billing_profile = billing_profile
        self.relationship_to_partner = relationship_to_partner
        self.allow_delegated_access = allow_delegated_access
        self.user_credentials = user_credentials
        self.associated_partner_id = associated_partner_id
        self.custom_domains = custom_domains
        self.links = links
        self.attributes = None
