# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1Order(Model):
    """Represents a collection of information needed to purchase offers
    represented by each order line item.
    A partner places an order when a customer wants to buy a subscription from
    a list of offers.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param id: Gets or sets the order identifier.
    :type id: str
    :param reference_customer_id: Gets or sets the reference customer
     identifier.
    :type reference_customer_id: str
    :param billing_cycle: Gets or sets the type of billing cycle for the
     selected offers.
     The billing cycle type indicates the frequency with which the partner is
     billed for this order.
     The default is "Monthly" at order creation. This field is applied upon
     successful creation of the order. Possible values include: 'unknown',
     'monthly', 'annual', 'none', 'one_time'
    :type billing_cycle: str or
     ~microsoft.store.partnercenterservices.models.enum
    :param currency_code: Gets or sets the currency code.
    :type currency_code: str
    :param line_items: Gets or sets an itemized list of the offers the
     customer is purchasing.
     Each order line item refers to the purchase data for one offer.
    :type line_items:
     list[~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1OrderLineItem]
    :param creation_date: Gets or sets the date and time the order was
     created.
    :type creation_date: datetime
    :param status: Gets or sets the order status. Possible values include:
     'unknown', 'completed', 'pending', 'cancelled'
    :type status: str or ~microsoft.store.partnercenterservices.models.enum
    :param links: Gets or sets the links corresponding to the order.
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1LinksOrderLinks
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'reference_customer_id': {'key': 'referenceCustomerId', 'type': 'str'},
        'billing_cycle': {'key': 'billingCycle', 'type': 'str'},
        'currency_code': {'key': 'currencyCode', 'type': 'str'},
        'line_items': {'key': 'lineItems', 'type': '[MicrosoftPartnerSdkContractsV1OrderLineItem]'},
        'creation_date': {'key': 'creationDate', 'type': 'iso-8601'},
        'status': {'key': 'status', 'type': 'str'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1LinksOrderLinks'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, id=None, reference_customer_id=None, billing_cycle=None, currency_code=None, line_items=None, creation_date=None, status=None, links=None):
        super(MicrosoftPartnerSdkContractsV1Order, self).__init__()
        self.id = id
        self.reference_customer_id = reference_customer_id
        self.billing_cycle = billing_cycle
        self.currency_code = currency_code
        self.line_items = line_items
        self.creation_date = creation_date
        self.status = status
        self.links = links
        self.attributes = None
