# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1UsageManagementPartnerUsageSummary(Model):
    """Represents a partner-level summary of usage budgeting for all customers
    with an Azure subscription.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param emails_to_notify: The list of email addresses for notifications.
    :type emails_to_notify: list[str]
    :param customers_over_budget: The number of customers that are over
     budget.
    :type customers_over_budget: int
    :param customers_trending_over: The number of customers that are close to
     going over budget.
    :type customers_trending_over: int
    :param customers_with_usage_based_subscription: The number of customers
     with a usage-based subscription.
    :type customers_with_usage_based_subscription: int
    :param resource_id: Gets or sets the resource unique identifier.
     A GUID formatted string that is the ID of the subscription or resource.
     In the context of CustomerMonthlyUsageRecord, this ID is the customer ID.
    :type resource_id: str
    :param id: To do: to be deprecated soon: The resource unique identifier.
    :type id: str
    :param resource_name: Gets or sets the name of the subscription or
     resource.
     In the context of CustomerMonthlyUsageRecord, this name is the customer
     name.
    :type resource_name: str
    :param name: To do: to be deprecated soon - The name of the resource.
    :type name: str
    :param billing_start_date: Gets or sets the start date of the current
     billing period, in date-time format.
    :type billing_start_date: datetime
    :param billing_end_date: Gets or sets the end date of the current billing
     period, in date-time format.
    :type billing_end_date: datetime
    :param total_cost: Gets or sets the estimated total cost of using the
     resources in the subscription during the specified billing period.
    :type total_cost: float
    :param currency_locale: Getsd or sets the locale in which the subscription
     was used, determines the currency to use on the invoice.
    :type currency_locale: str
    :param last_modified_date: Gets or sets the day, in date-time format, that
     this record was last modified.
    :type last_modified_date: datetime
    :param links: Gets or sets the links.
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceLinks
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'emails_to_notify': {'key': 'emailsToNotify', 'type': '[str]'},
        'customers_over_budget': {'key': 'customersOverBudget', 'type': 'int'},
        'customers_trending_over': {'key': 'customersTrendingOver', 'type': 'int'},
        'customers_with_usage_based_subscription': {'key': 'customersWithUsageBasedSubscription', 'type': 'int'},
        'resource_id': {'key': 'resourceId', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'resource_name': {'key': 'resourceName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'billing_start_date': {'key': 'billingStartDate', 'type': 'iso-8601'},
        'billing_end_date': {'key': 'billingEndDate', 'type': 'iso-8601'},
        'total_cost': {'key': 'totalCost', 'type': 'float'},
        'currency_locale': {'key': 'currencyLocale', 'type': 'str'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceLinks'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, emails_to_notify=None, customers_over_budget=None, customers_trending_over=None, customers_with_usage_based_subscription=None, resource_id=None, id=None, resource_name=None, name=None, billing_start_date=None, billing_end_date=None, total_cost=None, currency_locale=None, last_modified_date=None, links=None):
        super(MicrosoftPartnerSdkContractsV1UsageManagementPartnerUsageSummary, self).__init__()
        self.emails_to_notify = emails_to_notify
        self.customers_over_budget = customers_over_budget
        self.customers_trending_over = customers_trending_over
        self.customers_with_usage_based_subscription = customers_with_usage_based_subscription
        self.resource_id = resource_id
        self.id = id
        self.resource_name = resource_name
        self.name = name
        self.billing_start_date = billing_start_date
        self.billing_end_date = billing_end_date
        self.total_cost = total_cost
        self.currency_locale = currency_locale
        self.last_modified_date = last_modified_date
        self.links = links
        self.attributes = None
