# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1UserLicenseManagementSubscribedSku(Model):
    """Describes a subscribed product owned by a tenant.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param available_units: Gets or sets the number of units available for
     assignment. This is calculated as total units - consumed units.
    :type available_units: int
    :param active_units: Gets or sets the number of units active for
     assignment.
    :type active_units: int
    :param consumed_units: Gets or sets the number of units consumed.
    :type consumed_units: int
    :param suspended_units: Gets or sets the number of units suspended.
    :type suspended_units: int
    :param total_units: Gets or sets the total number of units. This is
     calculated as the sum of the active and warning units.
    :type total_units: int
    :param warning_units: Gets or sets the number of warning units.
    :type warning_units: int
    :param product_sku: Gets or sets the product SKU.
    :type product_sku:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1UserLicenseManagementProductSku
    :param service_plans: Gets or sets the collection of service plans of a
     product.
    :type service_plans:
     list[~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1UserLicenseManagementServicePlan]
    :param capability_status: Gets or sets the SKU status of a product.
    :type capability_status: str
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'available_units': {'key': 'availableUnits', 'type': 'int'},
        'active_units': {'key': 'activeUnits', 'type': 'int'},
        'consumed_units': {'key': 'consumedUnits', 'type': 'int'},
        'suspended_units': {'key': 'suspendedUnits', 'type': 'int'},
        'total_units': {'key': 'totalUnits', 'type': 'int'},
        'warning_units': {'key': 'warningUnits', 'type': 'int'},
        'product_sku': {'key': 'productSku', 'type': 'MicrosoftPartnerSdkContractsV1UserLicenseManagementProductSku'},
        'service_plans': {'key': 'servicePlans', 'type': '[MicrosoftPartnerSdkContractsV1UserLicenseManagementServicePlan]'},
        'capability_status': {'key': 'capabilityStatus', 'type': 'str'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, available_units=None, active_units=None, consumed_units=None, suspended_units=None, total_units=None, warning_units=None, product_sku=None, service_plans=None, capability_status=None):
        super(MicrosoftPartnerSdkContractsV1UserLicenseManagementSubscribedSku, self).__init__()
        self.available_units = available_units
        self.active_units = active_units
        self.consumed_units = consumed_units
        self.suspended_units = suspended_units
        self.total_units = total_units
        self.warning_units = warning_units
        self.product_sku = product_sku
        self.service_plans = service_plans
        self.capability_status = capability_status
        self.attributes = None
